function [f x_opt exitflag]=Bellman_mix_par(coef,i,beta,phi_L,phi_0,phi,theta,nu,alpha,Delta,g,...
    Ndeg_1,node_1,dz_1,extamin_1,Nnode_2,Ndeg_2,node_2,dz_2,extamin_2,Nnode_3,Ndeg_3,node_3,dz_3,extamin_3,...
    Nnode_4,Ndeg_4,node_4,dz_4,extamin_4, A2,A3,kappa1,kappa2,kappa3,rho,extamax_1,extamax_2)

f=zeros(Nnode_2,Nnode_3,Nnode_4); % vectorized value function
x_opt=zeros(Nnode_2,Nnode_3,Nnode_4,3); % (E1,E2,E3)
exitflag=zeros(Nnode_2,Nnode_3,Nnode_4);
options=optimset('Display','off','Algorithm','active-set','Tolfun',1e-14); % 'UseParallel','always'
int_x=[node_3(1)/2 1 1];
int_x=[0.1 0.1 1];

for j=1:Nnode_2 % state 2 (T)
    for k=1:Nnode_3 % state 3 (R)
        % int_x=[node_3(k)/2 1 1]; % the initial (E1, E2, E3)
        for m=1:Nnode_4
            
            % X'=sqrt(2)/2*(phi_L+(1-phi_L)*phi_0)*(x(1)+x(2))+(node_1(i)-node_2(j))/2+(1-phi)*(node_1(i)+node_2(j))/2
            % Y'=sqrt(2)/2*(-phi_L+(1-phi_L)*phi_0)*(x(1)+x(2))-(node_1(i)-node_2(j))/2+(1-phi)*(node_1(i)+node_2(j))/2
            % S'=sqrt(2)*X'=(phi_L+(1-phi_L)*phi_0)*(x(1)+x(2))+(node_1(i)-node_2(j))*sqrt(2)/2+(1-phi)*(node_1(i)+node_2(j))*sqrt(2)/2
            obj_fn=@(x)-(1/(1-theta*beta)*(nu/rho*log(kappa1*x(1)^rho+kappa2*x(2)^rho+kappa3*x(3)^rho)+...
                (1-theta-nu)*log(1-x(2)/A2/node_4(m)-x(3)/A3/node_4(m)))...
                +beta*(kron(cheb_par(dz_1*(sqrt(2)/2*(phi_L+(1-phi_L)*phi_0)*(x(1)+x(2))+(node_1(i)-node_2(j))/2+(1-phi)*(node_1(i)+node_2(j))/2-extamin_1)-1,Ndeg_1),...
                kron(cheb_par(dz_2*(sqrt(2)/2*(-phi_L+(1-phi_L)*phi_0)*(x(1)+x(2))-(node_1(i)-node_2(j))/2+(1-phi)*(node_1(i)+node_2(j))/2-extamin_2)-1,Ndeg_2),...
                kron(cheb_par(dz_3*(node_3(k)-x(1)-extamin_3)-1,Ndeg_3),...
                cheb_par(min(dz_4*(node_4(m)*(1+g)-extamin_4)-1,1),Ndeg_4))))*coef...
                +alpha*log(1-Delta*((phi_L+(1-phi_L)*phi_0)*(x(1)+x(2))+(node_1(i)-node_2(j))*sqrt(2)/2+(1-phi)*(node_1(i)+node_2(j))*sqrt(2)/2))));
            % add "-" to convert to minimization
            lb=[0 0 0];
%             ub=[min((1/Delta-node_1(i)-(1-phi)*node_2(j))/(phi_L+(1-phi_L)*phi_0), node_3(k))
%                 min((1/Delta-node_1(i)-(1-phi)*node_2(j))/(phi_L+(1-phi_L)*phi_0), min(A2*node_4(m),1e4))
%                 min(A3*node_4(m),1e4)];
            ub=[node_3(k) min(A2*node_4(m),1e4) min(A3*node_4(m),1e4)];
%             A=[1 1 0; 1 1 0];
%             b=[(extamax_1-node_1(i))/phi_L;
%                 (extamax_2-(1-phi)*node_2(j))/((1-phi_L)*phi_0)];
            A=[1 1 0; 1 1 0; 1 1 0];
            b=[(extamax_1-(node_1(i)-node_2(j))/2-(1-phi)*(node_1(i)+node_2(j))/2)*sqrt(2) / (phi_L+(1-phi_L)*phi_0);
                (extamax_2+(node_1(i)-node_2(j))/2-(1-phi)*(node_1(i)+node_2(j))/2)*sqrt(2) / (-phi_L+(1-phi_L)*phi_0);
                (1/Delta-(node_1(i)-node_2(j))*sqrt(2)/2-(1-phi)*(node_1(i)+node_2(j))*sqrt(2)/2) / (phi_L+(1-phi_L)*phi_0)];
            [x_opt(j,k,m,:) f(j,k,m) exitflag(j,k,m)]=fmincon(obj_fn,int_x,A,b,[],[],lb,ub,[],options); %%%
        end
    end
end

f=-f; % convert back to maximization problem.
end

