%% Method 1:
np=20; % number of period to draw
Dam_S=zeros(np,5);
S_seq_all=zeros(np,5);
alpha_vec=[0.01 0.1 1 100 Inf];
for idx_alpha=1:5
    % evaluate the first and second cell of Main_par.m
    dir_sim=['./alpha=' num2str(alpha_vec(idx_alpha)) ', 20 nodes on R,  2015 result/Simulation.mat'];
    load(dir_sim)
    Main_par_damage_only
    S_seq_all(:,idx_alpha)=P_seq(1:np)+T_seq(1:np);
    % load the correct data.
    % in Main_par.m, need to change alpha, R_stock, Pmax, Tmax, Nnode_1234;
    % Mix_regime_n1_1.mat, Mix_regime_n1_2.mat, Mix_regime_n1_3.mat all use
    % Pmax=Tmax=2000 as Mix_regime_n2.mat does.
    
    % P=103;
    % T=118;
    % R0=253.8;   % R=800 is used in the simulation grid
    % N=1;
    
    GDP=7e5;
    R_seq=zeros(size(P_seq));
    R_seq(1)=253.8; % do not use R_stock (when R_stock=800, R0=253.8!)
    for i=1:length(R_seq)-1
        R_seq(i+1)=R_seq(i)-E_seq(i,1);
    end
    for i=1:length(Dam_S)
        Dam_P=-(1-beta*theta)*kron(cheb_D_par(dz_1*(P_seq(i)-extamin_1)-1,Ndeg_1)*dz_1,...
            kron(cheb_par(dz_2*(T_seq(i)-extamin_2)-1,Ndeg_2),...
            kron(cheb_par(dz_3*(R_seq(i)-extamin_3)-1,Ndeg_3),...
            cheb_par(min(dz_4*(N_seq(i)-extamin_4)-1,1),Ndeg_4))))*coef;
        
        Dam_T=-(1-beta*theta)*kron(cheb_par(dz_1*(P_seq(i)-extamin_1)-1,Ndeg_1),...
            kron(cheb_D_par(dz_2*(T_seq(i)-extamin_2)-1,Ndeg_2)*dz_2,...
            kron(cheb_par(dz_3*(R_seq(i)-extamin_3)-1,Ndeg_3),...
            cheb_par(min(dz_4*(N_seq(i)-extamin_4)-1,1),Ndeg_4))))*coef;
        
        temp=phi_L*Dam_P+(1-phi_L)*phi_0/(1-phi)*Dam_T;
        % Dam_S(i,idx_alpha)=temp*GDP*(1+g)^(i-1);
        Dam_S(i,idx_alpha)=temp*GDP; % make the carbon tax adjusted for GDP.
        % This is done by replacing ($/ton of carbon) by ($/ton of carbon)*(GDP_2015/GDP_t)
    end
    % Dam_S=real(Dam_S);
end
%%
time_idx=(0:10:(np-1)*10)+2015;
xtick=[1:2:19 20];

figure(1)
plot(time_idx,Dam_S(1:np,2),'--k',time_idx,Dam_S(1:np,3),'-k',...
    time_idx,Dam_S(1:np,4),'-.k',time_idx,Dam_S(1:np,5),'ok','LineWidth',1.1)
xlabel('Year')
ylabel('$ / ton of carbon')
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
legend('\alpha=0.1', '\alpha=1','\alpha=100','\alpha=Inf','Location','East')
title('Optimal Carbon Tax (measured at constant GDP=$70 trillion)')
saveas(gcf,'Optimal_Carbon_Tax_2345.jpeg');

figure(2)
plot(time_idx,Dam_S(1:np,1),'-*k',time_idx,Dam_S(1:np,2),'--k',time_idx,Dam_S(1:np,3),'-k',...
    time_idx,Dam_S(1:np,4),'-.k',time_idx,Dam_S(1:np,5),'ok','LineWidth',1.1)
xlabel('Year')
ylabel('$ / ton of carbon')
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
legend('\alpha=0.01','\alpha=0.1', '\alpha=1','\alpha=100','\alpha=Inf','Location','East')
title('Optimal Carbon Tax (measured at constant GDP=$70 trillion)')
saveas(gcf,'Optimal_Carbon_Tax_12345.jpeg');

figure(3)
plot(S_seq_all(1:np,2),Dam_S(1:np,2),'--k',S_seq_all(1:np,3),Dam_S(1:np,3),'-k',...
    S_seq_all(1:np,4),Dam_S(1:np,4),'-.k',S_seq_all(1:np,5),Dam_S(1:np,5),'ok','LineWidth',1.1)
xlabel('Carbon Concentration Net of the Preindustrial Level (GtC)')
ylabel('$ / ton of carbon')
legend('\alpha=0.1', '\alpha=1','\alpha=100','\alpha=Inf','Location','East')
title('Optimal Carbon Tax (measured at constant GDP=$70 trillion)')
saveas(gcf,'Optimal_Carbon_Tax_against_S_2345.jpeg');

figure(4)
plot(S_seq_all(1:np,1),Dam_S(1:np,1),'-*k',S_seq_all(1:np,2),Dam_S(1:np,2),'--k',S_seq_all(1:np,3),Dam_S(1:np,3),'-k',...
    S_seq_all(1:np,4),Dam_S(1:np,4),'-.k',S_seq_all(1:np,5),Dam_S(1:np,5),'ok','LineWidth',1.1)
xlabel('Carbon Concentration Net of the Preindustrial Level (GtC)')
ylabel('$ / ton of carbon')
legend('\alpha=0.01','\alpha=0.1', '\alpha=1','\alpha=100','\alpha=Inf','Location','East')
title('Optimal Carbon Tax (measured at constant GDP=$70 trillion)')
saveas(gcf,'Optimal_Carbon_Tax_against_S_12345.jpeg');

%% Method 2: (dropped)
% below, change R_seq(1). load the correct data.
% GDP=7e5;
% S_seq=P_seq+T_seq;
% beta_P=zeros(18,1);
% beta_T=zeros(18,1);
% beta_P(1)=beta;
% beta_T(1)=beta*(1-phi);
%
% for i=2:18
%     beta_P(i)=beta_P(i-1)*beta;
%     beta_T(i)=beta_T(i-1)*beta*(1-phi);
% end
%
% Damage_P=beta*theta*mu/(1-beta)+theta*A_bar*sigma2/alpha*dot(beta_P,S_seq(2:19));
% Damage_T=beta*theta*mu*(1-phi)/(1-(1-phi)*beta)+theta*A_bar*sigma2/alpha*dot(beta_T,S_seq(2:19));
% Damage_S=phi_L*Damage_P+(1-phi_L)*phi_0/(1-phi)*Damage_T;
% Damage_S=Damage_S*GDP;
% Damage_S_inf=beta*theta*mu*(phi_L/(1-beta)+(1-phi_L)*phi_0/(1-(1-phi)*beta));
% Damage_S_inf=Damage_S_inf*GDP;
%%
% load Mix_regime_n1_2.mat
% GDP=7e5;
% add=0;
% P=103+add;
% T=118-add;
% R=253.8;
% N=1;
%
% Dam_P=-(1-beta*theta)*kron(cheb_D_par(dz_1*(P-extamin_1)-1,Ndeg_1)*dz_1,...
%     kron(cheb_par(dz_2*(T-extamin_2)-1,Ndeg_2),...
%     kron(cheb_par(dz_3*(R-extamin_3)-1,Ndeg_3),...
%     cheb_par(min(dz_4*(N-extamin_4)-1,1),Ndeg_4))))*coef;
%
% Dam_T=-(1-beta*theta)*kron(cheb_par(dz_1*(P-extamin_1)-1,Ndeg_1),...
%     kron(cheb_D_par(dz_2*(T-extamin_2)-1,Ndeg_2)*dz_2,...
%     kron(cheb_par(dz_3*(R-extamin_3)-1,Ndeg_3),...
%     cheb_par(min(dz_4*(N-extamin_4)-1,1),Ndeg_4))))*coef;
% Dam_S=phi_L*Dam_P+(1-phi_L)*phi_0/(1-phi)*Dam_T;
% Dam_S=Dam_S*GDP;




