function [T,dT,ddT]=cheb_all(z,Nnode,Ndeg)

T=zeros(Nnode,Ndeg+1);
dT=zeros(Nnode,Ndeg+1);
ddT=zeros(Nnode,Ndeg+1);

for i=1:Nnode
    T(i,1) = 1;
    T(i,2) = z(i);
    dT(i,1) = 0;
    dT(i,2) = 1;
    ddT(i,1) = 0;
    ddT(i,2) = 0;
    for j=2:Ndeg
        T(i,j+1) = 2*z(i)*T(i,j) - T(i,j-1);
        dT(i,j+1) = 2*T(i,j) + 2*z(i)*dT(i,j) - dT(i,j-1);
        ddT(i,j+1) = 4*dT(i,j) + 2*z(i)*ddT(i,j) - ddT(i,j-1);
    end
end
