
%%
global beta kappa1 kappa2 kappa3 rho theta nu A2 A3 g mu sigma2

np=20; % number of period to draw
time_idx=(0:10:(np-1)*10)+2015;
xtick=[1:2:19 20];

K0=0.1;
S_bar=581;
alpha_w=[0.01;Inf];  
Delta_w=theta/(1-beta*theta)*sigma2./alpha_w;

all_E_seq=zeros(np,3,2);
all_P_seq=zeros(np,2);
all_T_seq=zeros(np,2);
all_S_seq=zeros(np,2);
mu_w=zeros(np,2);

% simulation under the approximating model
K_a=zeros(np,2); y_a=zeros(np,2); E_a=zeros(np,2);
K_a(1,1)=K0; K_a(1,2)=K0; 
% simulation under the worst case model
K_w=zeros(np,2); y_w=zeros(np,2); E_w=zeros(np,2);
K_w(1,1)=K0; K_w(1,2)=K0; 

load './alpha=0.01, 20 nodes on R,  2015 result/Simulation.mat' % alpha=0.01
all_E_seq(:,:,1)=E_seq(1:np,:);
all_P_seq(:,1)=P_seq(1:np);
all_T_seq(:,1)=T_seq(1:np);
all_S_seq(:,1)=all_P_seq(:,1)+all_T_seq(:,1);
mu_w(:,1)=mu+Delta_w(1)*all_S_seq(:,1); % worst case mu.

% simulation under the approximating model 
for t=1:np
    E_a(t,1)=(kappa1*E_seq(t,1)^rho+kappa2*E_seq(t,2)^rho+kappa3*E_seq(t,3)^rho)^(1/rho);
    y_a(t,1)=K_a(t,1)^theta*E_a(t,1)^nu*(1-E_seq(t,2)/A2/(1+g)^(t-1)-E_seq(t,3)/A3/(1+g)^(t-1))^(1-theta-nu);
    if t<np
    K_a(t+1,1)=(beta*theta)*exp(-all_S_seq(t+1,1)*mu)*y_a(t,1);
    end
end
% simulation under the worst case model
for t=1:np
    E_w(t,1)=(kappa1*E_seq(t,1)^rho+kappa2*E_seq(t,2)^rho+kappa3*E_seq(t,3)^rho)^(1/rho);
    y_w(t,1)=K_w(t,1)^theta*E_w(t,1)^nu*(1-E_seq(t,2)/A2/(1+g)^(t-1)-E_seq(t,3)/A3/(1+g)^(t-1))^(1-theta-nu);
    if t<np
    K_w(t+1,1)=(beta*theta)*exp(-all_S_seq(t+1,1)*mu_w(t+1,1))*y_w(t,1);
    % use mu_w(t+1,1), which corresponds to the worst case under
    % alpha=0.001.
    end
end


load './alpha=Inf, 20 nodes on R,  2015 result/Simulation.mat' % alpha=Inf
all_E_seq(:,:,2)=E_seq(1:np,:);
all_P_seq(:,2)=P_seq(1:np);
all_T_seq(:,2)=T_seq(1:np);
all_S_seq(:,2)=all_P_seq(:,2)+all_T_seq(:,2);
mu_w(:,2)=mu+Delta_w(1)*all_S_seq(:,2); % worst case mu.

% simulation under the approximating model
for t=1:np
    E_a(t,2)=(kappa1*E_seq(t,1)^rho+kappa2*E_seq(t,2)^rho+kappa3*E_seq(t,3)^rho)^(1/rho);
    y_a(t,2)=K_a(t,2)^theta*E_a(t,2)^nu*(1-E_seq(t,2)/A2/(1+g)^(t-1)-E_seq(t,3)/A3/(1+g)^(t-1))^(1-theta-nu);
    if t<np
    K_a(t+1,2)=(beta*theta)*exp(-all_S_seq(t+1,2)*mu)*y_a(t,2);
    end
end
% simulation under the worst case model
for t=1:np
    E_w(t,2)=(kappa1*E_seq(t,1)^rho+kappa2*E_seq(t,2)^rho+kappa3*E_seq(t,3)^rho)^(1/rho);
    y_w(t,2)=K_w(t,2)^theta*E_w(t,2)^nu*(1-E_seq(t,2)/A2/(1+g)^(t-1)-E_seq(t,3)/A3/(1+g)^(t-1))^(1-theta-nu);
    if t<np
    K_w(t+1,2)=(beta*theta)*exp(-all_S_seq(t+1,2)*mu_w(t+1,2))*y_w(t,2); 
    % use mu_w(t+1,1), which corresponds to the worst case under
    % alpha=0.001.
    end
end


%%
figure(1)
idx_subplot=[1:9 (1:9)+21 (1:9)+21*2];
subplot(10,21,idx_subplot) %1
plot(time_idx,all_E_seq(:,3,1)/10,'--*k',time_idx,all_E_seq(:,3,2)/10,'-k', 'LineWidth',1.3)
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
xlabel('Year')
ylabel('GtC per year')
% legend(['\alpha=' num2str(alpha_w(1))],['\alpha=' num2str(alpha_w(2))],'Location','Best')
title('Optimal Green Energy Use')

subplot(10,21,idx_subplot+12) %2
plot(time_idx,all_E_seq(:,2,1)/10,'--*k',time_idx,all_E_seq(:,2,2)/10,'-k', 'LineWidth',1.3)
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
xlabel('Year')
ylabel('GtC per year')
% legend(['\alpha=' num2str(alpha_w(1))],['\alpha=' num2str(alpha_w(2))],'Location','Best')
title('Optimal Coal Use')

subplot(10,21,idx_subplot+21*5) %3
plot(time_idx,all_E_seq(:,1,1)/10,'--*k',time_idx,all_E_seq(:,1,2)/10,'-k', 'LineWidth',1.3)
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
xlabel('Year')
ylabel('GtC per year')
% legend(['\alpha=' num2str(alpha_w(1))],['\alpha=' num2str(alpha_w(2))],'Location','Best')
title('Optimal Oil Use')

subplot(10,21,idx_subplot+21*5+12) %4
ph=plot(time_idx,all_S_seq(:,1),'--*k',time_idx,all_S_seq(:,2),'-k', 'LineWidth',1.3);
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
xlabel('Year')
ylabel('GtC')
% legend(['\alpha=' num2str(alpha_w(1))],['\alpha=' num2str(alpha_w(2))],'Location','Best')
title({'Optimal Carbon Concentration','(net of the preindustrial level)'})

sh=subplot(10,21,21*9+(7:15)); % legend
p=get(sh,'position');
lh=legend(sh,ph,['\alpha=' num2str(alpha_w(1))],['\alpha=' num2str(alpha_w(2))],'Location','BestOutside');
set(lh,'position',p);
axis(sh,'off');
saveas(gcf,'Optimal_Use_Comp.jpeg');

%%
figure(2)
idx_subplot=[1:9 (1:9)+21 (1:9)+21*2];
subplot(24,21,idx_subplot) %1
plot(time_idx,(1-exp(-all_S_seq(:,1)*mu))*100,'--*k',time_idx,(1-exp(-all_S_seq(:,2)*mu))*100,'-k', 'LineWidth',1.3)
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
xlabel('Year')
% ylabel('Percent of Capital Stock')
ylabel('(%)')
title({'Total damages as a percent of Capital Stock','(based on the approximating model)'})

subplot(24,21,idx_subplot+12) %2
plot(time_idx,(1-exp(-all_S_seq(:,1).*mu_w(:,1)))*100,'--*k',time_idx,(1-exp(-all_S_seq(1:np,2).*mu_w(1:np,2)))*100,'-k', 'LineWidth',1.3)
% use lambda_w(t+1,1), which corresponds to the worst case under
% alpha=0.01.
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
xlabel('Year')
% ylabel('Percent of Capital Stock')
ylabel('(%)')
title({'Total damages as a percent of Capital Stock','(based on the worst case model)'})

subplot(24,21,idx_subplot+21*8) %3 
% under the approximating model
plot(time_idx,K_a(:,1),'--*k',time_idx,K_a(:,2),'-k', 'LineWidth',1.3)
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
xlabel('Year')
ylabel('Capital Stock')
title({'Capital Stock','(based on the approximating model)'})

subplot(24,21,idx_subplot+21*8+12) %4
% under the worst case model
plot(time_idx,K_w(:,1),'--*k',time_idx,K_w(1:np,2),'-k', 'LineWidth',1.3)
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
xlabel('Year')
ylabel('Capital Stock')
title({'Capital Stock','(based on the worst case model)'})

subplot(24,21,idx_subplot+21*16) %5  
% under the approximating model
plot(time_idx,y_a(:,1),'--*k',time_idx,y_a(:,2),'-k', 'LineWidth',1.3)
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
xlabel('Year')
ylabel('GDP per period (10 years)')
title({'GDP per Period','(based on the approximating model)'})

subplot(24,21,idx_subplot+21*16+12) %6  
% under the worst case model
ph=plot(time_idx,y_w(:,1),'--*k',time_idx,y_w(1:np,2),'-k', 'LineWidth',1.3);
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
xlabel('Year')
ylabel('GDP per period (10 years)')
title({'GDP per Period','(based on the worst case model)'})

sh=subplot(24,21,21*23+(7:15)); % legend
p=get(sh,'position');
lh=legend(sh,ph,['\alpha=' num2str(alpha_w(1))],['\alpha=' num2str(alpha_w(2))],'Location','BestOutside');
set(lh,'position',p);
axis(sh,'off');
saveas(gcf,'Capital_GDP_Comp.jpeg');

%%
figure(3)
plot(time_idx,3*log(all_S_seq(:,1)/S_bar+1)/log(2),'--*k',time_idx,3*log(all_S_seq(:,2)/S_bar+1)/log(2),'-k', 'LineWidth',1.3)
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
xlabel('Year')
ylabel('Degree Celsius')
legend(['\alpha=' num2str(alpha_w(1))],['\alpha=' num2str(alpha_w(2))],'Location','Best')
title({'Increases in Global Temperature'})
saveas(gcf,'Temperature_Comp.jpeg');


%%
% figure(4)
% 
% subplot(211)
% plot(time_idx,all_E_seq(:,1,1)/10)
% xlabel('Year')
% ylabel('GtC per year')
% legend('E_1^{\alpha=0.01}','Location','Best')
% title('Optimal Oil Uses when \alpha=0.01')
% 
% subplot(212)
% plot(time_idx,all_E_seq(:,1,2)/10)
% xlabel('Year')
% ylabel('GtC per year')
% legend('E_1^{\alpha=Inf}','Location','Best')
% title('Optimal Oil Uses when \alpha=Inf')
% saveas(gcf,'Optimal Oil Uses.jpeg');





