function [new_coef exit_quad]=shape_pre(f,coef)
% find new_coef that satisfies the shape properties.
global Nnode_1 Nnode_2 Nnode_3 Nnode_4 T4 TT4 dT4 ddT4 weights4

options=optimset('Display','off','Algorithm','interior-point-convex');
A=[dT4;ddT4];
b=zeros(8*Nnode_1*Nnode_2*Nnode_3*Nnode_4,1);
new_coef=zeros(length(coef),1);

I_select=0;
if I_select==1
    idx=abs(coef)>1e-5;
    coef=coef(idx);
    A=A(:,idx);
    t4=T4(:,idx);
    temp=1./weights4;
    tt4=sparse(diag(temp(idx)));
    [new_coef_temp, ~, exit_quad]=quadprog(tt4,-(f'*t4)',A,b,[],[],[],[],coef,options);
    new_coef(idx)=new_coef_temp;
    new_coef(~idx)=0;
else
    [new_coef, ~, exit_quad]=quadprog(TT4,-(f'*T4)',A,b,[],[],[],[],coef,options);
end



