function [f x_opt exitflag]=Bellman_mix_par(coef,i,beta,phi_L,phi_0,phi,theta,nu,A_bar,Delta,g,mu,...
    Ndeg_1,node_1,dz_1,extamin_1,Nnode_2,Ndeg_2,node_2,dz_2,extamin_2,Nnode_3,Ndeg_3,node_3,dz_3,extamin_3,...
    A2,A3,kappa1,kappa2,kappa3,rho)

f=zeros(Nnode_2,Nnode_3); % vectorized value function
x_opt=zeros(Nnode_2,Nnode_3,3); % (E1,E2,E3)
exitflag=zeros(Nnode_2,Nnode_3);
options=optimset('Display','off','Algorithm','active-set','Tolfun',1e-14); % 'UseParallel','always'
int_x=[1 1 1];

for j=1:Nnode_2 % state 2 (T)
    for k=1:Nnode_3
        obj_fn=@(x)-(1/(1-theta*beta)*(nu/rho*log(kappa1*x(1)^rho+kappa2*x(2)^rho+kappa3*x(3)^rho)+(1-theta-nu)*log(1-x(2)/A2/node_3(k)-x(3)/A3/node_3(k)))...
            +beta*(kron(cheb_par(dz_1*(node_1(i)+phi_L*(x(1)+x(2))-extamin_1)-1,Ndeg_1),...
            kron(cheb_par(dz_2*((1-phi)*node_2(j)+(1-phi_L)*phi_0*(x(1)+x(2))-extamin_2)-1,Ndeg_2),...
            cheb_par(min(dz_3*(node_3(k)*(1+g)-extamin_3)-1,1),Ndeg_3))))*coef...
            -A_bar*(node_1(i)+(1-phi)*node_2(j)+(phi_L+(1-phi_L)*phi_0)*(x(1)+x(2)))*(mu+Delta*(node_1(i)+(1-phi)*node_2(j)+(phi_L+(1-phi_L)*phi_0)*(x(1)+x(2)))));
        % add "-" to convert to minimization
        lb=[0 0 0];
        ub=[1e4,min(A2*node_3(k),1e4),min(A3*node_3(k),1e4)];
        [x_opt(j,k,:) f(j,k) exitflag(j,k)]=fmincon(obj_fn,int_x,[],[],[],[],lb,ub,[],options); %%%
    end
end

f=-f; % convert back to maximization problem.
end

