function [new_coef exit_quad]=shape_pre(f,coef)
% find new_coef that satisfies the shape properties.
global Nnode_1 Nnode_2 Nnode_3 T3 TT3 dT3 ddT3 weights3

options=optimset('Display','off','Algorithm','interior-point-convex');
A=[dT3;ddT3];
b=zeros(6*Nnode_1*Nnode_2*Nnode_3,1);
new_coef=zeros(length(coef),1);

I_select=0;
if I_select==1
    idx=abs(coef)>1e-5;
    coef=coef(idx);
    A=A(:,idx);
    t3=T3(:,idx);
    temp=1./weights3;
    tt3=sparse(diag(temp(idx)));
    [new_coef_temp, ~, exit_quad]=quadprog(tt3,-(f'*t3)',A,b,[],[],[],[],coef,options);
    new_coef(idx)=new_coef_temp;
    new_coef(~idx)=0;
else
    [new_coef, ~, exit_quad]=quadprog(TT3,-(f'*T3)',A,b,[],[],[],[],coef,options);
end



