function [f x_opt exitflag]=Bellman_mix_par(coef,i,beta,phi_L,phi_0,phi,theta,nu,A_bar,Delta,g,mu,...
    Ndeg_1,node_1,dz_1,extamin_1,Nnode_2,Ndeg_2,node_2,dz_2,extamin_2,Nnode_3,Ndeg_3,node_3,dz_3,extamin_3,...
    Nnode_4,Ndeg_4,node_4,dz_4,extamin_4, Nnode_5,Ndeg_5,node_5,dz_5,extamin_5, A2,A3,kappa1,kappa2,kappa3,rho)

f=zeros(Nnode_2,Nnode_3,Nnode_4,Nnode_5); % vectorized value function
x_opt=zeros(Nnode_2,Nnode_3,Nnode_4,Nnode_5,3); % (E1,E2,E3)
exitflag=zeros(Nnode_2,Nnode_3,Nnode_4,Nnode_5);
options=optimset('Display','off','Algorithm','active-set','Tolfun',1e-14); % 'UseParallel','always'
int_x=[node_3(1)/2 1 1];

for j=1:Nnode_2 % state 2 (T)
    for k=1:Nnode_3 % state 3 (R)
        % int_x=[node_3(k)/2 1 1]; % the initial (E1, E2, E3)
        for m=1:Nnode_4
            for n=1:Nnode_5
                obj_fn=@(x)-(1/(1-theta*beta)*(nu/rho*log(kappa1*x(1)^rho+kappa2*x(2)^rho+kappa3*x(3)^rho)+(1-theta-nu)*log(1-x(2)/A2/node_4(m)-x(3)/A3/node_4(m)))...
                    +beta*(kron(cheb_par(dz_1*(node_1(i)+phi_L*(x(1)+x(2))-extamin_1)-1,Ndeg_1),...
                    kron(cheb_par(dz_2*((1-phi)*node_2(j)+(1-phi_L)*phi_0*(x(1)+x(2))-extamin_2)-1,Ndeg_2),...
                    kron(cheb_par(dz_3*(node_3(k)-x(1)-extamin_3)-1,Ndeg_3),...
                    kron(cheb_par(min(dz_4*(node_4(m)*(1+g)-extamin_4)-1,1),Ndeg_4),...
                    cheb_par(dz_5*(node_5(n)-x(2)-extamin_5)-1,Ndeg_5)))))*coef...
                    -A_bar*(node_1(i)+(1-phi)*node_2(j)+(phi_L+(1-phi_L)*phi_0)*(x(1)+x(2)))*(mu+Delta*(node_1(i)+(1-phi)*node_2(j)+(phi_L+(1-phi_L)*phi_0)*(x(1)+x(2))))));
                % add "-" to convert to minimization
                lb=[0 0 0];
                ub=[node_3(k),min(A2*node_4(m),node_5(n)),min(A3*node_4(m),1e4)];
                [x_opt(j,k,m,n,:), f(j,k,m,n), exitflag(j,k,m,n)]=fmincon(obj_fn,int_x,[],[],[],[],lb,ub,[],options); %%%
            end
        end
    end
end

f=-f; % convert back to maximization problem.
end

