np=21;
comp_E_use=zeros(np,3,4);
comp_S=zeros(np,4);
dir={'./unlim_coal, alpha=Inf, 20 nodes on R,  2015 result/Simulation.mat',...
    './unlim_coal, alpha=0.01, 20 nodes on R,  2015 result/Simulation.mat'...
    './lim_coal, alpha=Inf, 10 nodes on R_coal/Simulation.mat',...
    './lim_coal, alpha=0.01 5 nodes on R_coal/Simulation.mat'};
for i=1:4
    load(dir{i},'E_seq','P_seq','T_seq')
    comp_E_use(:,:,i)=E_seq;
    comp_S(:,i)=P_seq(1:np)+T_seq(1:np);
end

%%
close all
np=21; % number of period to draw
time_idx=(0:10:(np-1)*10)+2015;
xtick=1:2:21;
idx_subplot=[1:9 (1:9)+21 (1:9)+21*2];

subplot(10,21,idx_subplot) %1
plot(time_idx,comp_E_use(:,3,1)/10,'-k',time_idx,comp_E_use(:,3,2)/10,'--*k',time_idx,comp_E_use(:,3,3)/10,'dk',...
    time_idx,comp_E_use(:,3,4)/10,'ok', 'LineWidth',1.5)
ylim([0 max(max(comp_E_use(:,3,:)/10))*1.2])
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
xlabel('Year')
ylabel('GtC equivalent per year')
title('Optimal Green Energy Use')

subplot(10,21,idx_subplot+12) %2
plot(time_idx,comp_E_use(:,2,1)/10,'-k',time_idx,comp_E_use(:,2,2)/10,'--*k',time_idx,comp_E_use(:,2,3)/10,'dk',...
    time_idx,comp_E_use(:,2,4)/10,'ok', 'LineWidth',1.5)
ylim([0 max(max(comp_E_use(:,2,:)/10))*1.2])
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
xlabel('Year')
ylabel('GtC per year')
title('Optimal Coal Use')

subplot(10,21,idx_subplot+21*5) %3
plot(time_idx,comp_E_use(:,1,1)/10,'-k',time_idx,comp_E_use(:,1,2)/10,'--*k',time_idx,comp_E_use(:,1,3)/10,'dk',...
    time_idx,comp_E_use(:,1,4)/10,'ok', 'LineWidth',1.5)
ylim([0 max(max(comp_E_use(:,1,:)/10))*1.2])
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
xlabel('Year')
ylabel('GtC per year')
title('Optimal Oil Use')

subplot(10,21,idx_subplot+21*5+12) %4
ph=plot(time_idx,comp_S(:,1),'-k',time_idx,comp_S(:,2),'--*k',time_idx,comp_S(:,3),'dk',...
    time_idx,comp_S(:,4),'ok', 'LineWidth',1.5);
ylim([200 max(max(comp_S))*1.2])
xlim([min(time_idx) max(time_idx) ])
set(gca,'XTick',time_idx(xtick),'XTickLabel',time_idx(xtick),'XTickLabelRotation',45)
xlabel('Year')
ylabel('GtC')
title({'Optimal Carbon Concentration','(net of the preindustrial level)'})

sh=subplot(10,21,21*9+(7:15)); % legend
p=get(sh,'position');
lh=legend(sh,ph,'unlimited coal, \alpha=Inf','unlimited coal, \alpha=0.01','limited coal, \alpha=Inf',...
    'limited coal, \alpha=0.01','Location','BestOutside');
set(lh,'position',p);
axis(sh,'off');

saveas(gcf,'Optimal_Use_Comp.jpeg');

























